<template>
    <div
        :class="{
            'size-lg': size === 'lg',
            'dark': !!dark
        }"
    >
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': errors && errors.length,
                'text-red-500': errors && errors.length,
                'font-black': boldLabel,
            }"
        >
            {{ label || name }}
        </label>
        <div
            class="mt-1 relative rounded-sm shadow-sm"
        >
            <div
                v-if="dollarSign"
                class="absolute inset-y-0 left-0 flex items-center cursor-pointer pl-5 text-2xl font-bold font-mono"
            >
                $
            </div>
            <input
                :id="id"
                :type="type"
                :name="name"
                :placeholder="placeholder"
                :value="data"
                :disabled="disabled"
                :readonly="readonly"
                class="form-control"
                :class="{
                    '!pl-11': dollarSign,
                    '!pr-15': appendButton && appendButtonText,
                    'border-gray-300': !errors,
                    'border-red-500': errors && errors.length,
                    'text-red-500': errors && errors.length,
                    'opacity-50': disabled || readonly,
                    'disabled': disabled || readonly,
                }"
                :style="{
                    'padding-right': `${appendButtonWidth}px !important`
                }"
                @input="data = $event.target.value"
                @blur="emit('blur')"
                @keypress="checkForRestriction"
            >
            <div
                v-if="appendButton && appendButtonText"
                class="absolute inset-y-0 right-2 flex items-center cursor-pointer uppercase !text-xs leading-tight"
                @click="appendButtonClick"
            >
                <div
                    ref="appendButtonRef"
                    :class="{
                        'bg-slate-700 text-white': dark,
                        '!px-4 !py-1.5': size === 'lg',
                        '!px-2 !py-1': size !== 'lg',
                    }"
                >
                    {{ appendButtonText }}
                </div>
            </div>
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="errors && errors.length"
        >
            <div
                v-for="(err, i) in errors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {ref, watch, computed} from 'vue';
import BigNumber from "bignumber.js";
const props = defineProps({
    id: {
        required: false,
        type: [String, Number],
        default: null,
    },
    name: {
        required: true,
        type: [String, Number],
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    type: {
        required: false,
        type: [String],
        default: 'text',
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    modelValue: {
        required: false,
        type: [String, Number, Boolean, BigNumber],
        default: '',
    },
    errors: {
        required: false,
        type: Array,
        default: () => [],
    },
    prependIcon: {
        required: false,
        type: String,
        default: null,
    },
    appendIcon: {
        required: false,
        type: String,
        default: null,
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    },
    fund: {
        required: false,
        type: Boolean,
        default: false,
    },
    number: {
        required: false,
        type: Boolean,
        default: false,
    },
    size: {
        required: false,
        type: String,
        default: 'md',
    },
    dark: {
        required: false,
        type: Boolean,
        default: false,
    },
    dollarSign: {
        required: false,
        type: Boolean,
        default: false,
    },
    appendButton: {
        required: false,
        type: Boolean,
        default: false,
    },
    appendButtonText: {
        required: false,
        type: [String, Number],
        default: null
    },
    appendButtonSetValue: {
        required: false,
        type: [String, Number, BigNumber],
        default: null,
    }
});
let data = ref(props.modelValue);
const emit = defineEmits(['update:modelValue', 'appendButtonCallback', 'blur']);
const appendButtonRef = ref();

watch(data, (newValue, oldValue) => {
    if (newValue !== oldValue) {
        emit('update:modelValue', newValue);
    }
});

const checkForRestriction = (event) => {
    if (props.fund) {
        // console.log($event.keyCode); //keyCodes value
        let keyCode = (event.keyCode ? event.keyCode : event.which);

        // only allow number and one dot
        if ((keyCode < 48 || keyCode > 57) && (keyCode !== 46 || (data.value && data.value.indexOf('.') !== -1))) { // 46 is dot
            event.preventDefault();
        }

        // restrict to 2 decimal places
        if(data.value != null && data.value.indexOf(".") > -1 && (data.value && data.value.split('.')[1].length > 1)) {
            event.preventDefault();
        }
    } else if (props.number) {
        let keyCode = (event.keyCode ? event.keyCode : event.which);

        // only allow number
        if (keyCode < 48 || keyCode > 57) {
            event.preventDefault();
        }
    }
};

const appendButtonClick = () => {
    if (props.appendButton) {
        if (props.appendButtonSetValue !== null) {
            data.value = props.appendButtonSetValue;
        }
        emit('appendButtonCallback');
    }
};

const appendButtonWidth = computed(() => {
    if (!appendButtonRef.value) return 0;
    return appendButtonRef.value.clientWidth + 15;
});

const forceUpdateValue = (v) => {
    data.value = v;
};

defineExpose({
    forceUpdateValue,
});
</script>
